# srecover2D.py modifyed for Ex. 7.8
from visualization import *
# Open the output data base for the current Job
odb = openOdb(path='Job-1.odb');
myAssembly = odb.rootAssembly;

# Creating a temporary variable to hold the frame repository speeds up the process
# In Ex. 7.8, Step-2 is the relaxation step
frameRepository = odb.steps['Step-2'].frames;

# Get the results for frame [i], where i is the increment number
i = 80
frameS = frameRepository[i].fieldOutputs['S'].values;
frameE = frameRepository[i].fieldOutputs['E'].values;
frameIVOL = frameRepository[i].fieldOutputs['IVOL'].values;

Tot_Vol=0.;         # Total Volume
Tot_Stress=0.;      # Stress Sum
Tot_Strain = 0.;    # Strain Sum

# Calculate Average
for II in range(0,len(frameS)):
     Tot_Vol+=frameIVOL[II].data;
     Tot_Stress+=frameS[II].data * frameIVOL[II].data;
     Tot_Strain+=frameE[II].data * frameIVOL[II].data;

Avg_Stress = Tot_Stress/Tot_Vol;
Avg_Strain = Tot_Strain/Tot_Vol; 

# from Abaqus Analysis User's Manual - 1.2.2 Conventions - 
# Convention used for stress and strain components
print '2D Abaqus/Standard Stress Tensor Order: 11-22-33-12'
print 'Average stresses Global CSYS: 11-22-33-12';
print Avg_Stress;
print 'Average strain Global CSYS: 11-22-33-12';
print Avg_Strain;
odb.close()